#define  BOOST_FILESYSTEM_VERSION 2
#include "common.h"
#include <boost/filesystem.hpp>



namespace harkio {
using namespace std;

ostream& operator<<(ostream& os, Error& error) {
	os << error.what();
	return os;
}
ostream& Error::print(ostream &out) {
	out << (*this) << endl;
	return out;
}

std::string toFullPath(std::string base, std::string target) {

	namespace bf = boost::filesystem;

	// targetが絶対パスの時はそのまま返す
	bf::path target_path(target);
	if (target_path.root_path() != "") {
		return target;
	}

	if (base == "") {
		base = boost::filesystem::current_path().string();
	}
	char fname[PATH_MAX] = "";
	// baseがシンボリックリンクの場合は参照先を見る
	if (bf::is_symlink(base)) {
		int ret = readlink(base.c_str(), fname , sizeof(fname));
		(void)ret;
		base = fname;
	}
	// baseがファイルの場合は、ディレクトリ部分を残す
	bf::path base_path(base);
	if (bf::is_regular_file(base)) {
		base_path.remove_filename();
	}
	base_path /= target_path; // 連結
	base_path.canonize(); // 正規化

	return base_path.string();

}

} // namespace
